<?php

if ( ! defined( 'ABSPATH' ) ) exit;

class Wplms_Multi_Meta_Db{
	public static $instance;

    public static function init(){

        if ( is_null( self::$instance ) )
            self::$instance = new Wplms_Multi_Meta_Db();
        return self::$instance;
    }

	public function __construct() {
		global $wpdb;
		$this->table_name  = $wpdb->base_prefix . 'blog_usermeta_map';
		//$this->table_name  = $wpdb->prefix . 'blog_usermeta_map';
		$this->version = '1.0';
	}
	public function create_table() {
		global $wpdb;
		require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
		$sql = "CREATE TABLE " . $this->table_name . " (
		meta_id bigint(20) NOT NULL,
		blog_id bigint(20),
		
		PRIMARY KEY  (meta_id)
		) CHARACTER SET utf8 COLLATE utf8_general_ci;";

		dbDelta( $sql );
		update_option( $this->table_name . '_db_version', $this->version );
	}

	public function table_exists($table){
		global $wpdb;
		$table = sanitize_text_field( $table );
		return $wpdb->get_var( $wpdb->prepare( "SHOW TABLES LIKE '%s'", $table ) ) === $table;
	}

	public function update($meta_id,$blog_id){
		global $wpdb;
		$existing_meta_id = $wpdb->get_var($wpdb->prepare("SELECT meta_id FROM {$this->table_name} WHERE meta_id=%d AND blog_id=%d",$meta_id,$blog_id));
		
		if(!empty($existing_meta_id)){
			//run update command 
			$updated = $wpdb->update( 
				$this->table_name, 
				array( 
					'blog_id' => $blog_id,
				), 
				array( 'meta_id' => $meta_id ), 
				array( 
					'%d',	// value1
				), 
				array( '%d' ) 
			);
			if($updated){
				return $meta_id;
			}
		}else{
			//run insert command
			$meta_id = $wpdb->insert( 
				$this->table_name,
				array( 
					'blog_id' => $blog_id, 
					'meta_id' => $meta_id,
				), 
				array( 
					'%d', 
					'%d' 
				) 
			);
			return $meta_id;
		}
	}

}